#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "SDL.h"

static Uint8 rmask[4] = { 0xff, 0, 0, 0 };
static Uint8 gmask[4] = { 0, 0xff, 0, 0 };
static Uint8 bmask[4] = { 0, 0, 0xff, 0 };
static Uint8 amask[4] = { 0, 0, 0, 0xff };

SDL_Surface *
IF_Load_RW(SDL_RWops *ctx)
{
	char hdr[17];
	int w, h;
	SDL_Surface *surf;

	if (SDL_RWread(ctx, hdr, 1, 17) < 17)
		return NULL;

	if (memcmp(hdr, "imagefile", 9) != 0) {
		SDL_SetError("Not an imagefile");
		return NULL;
	}

	w = (hdr[9]<<24) | (hdr[10]<<16) | (hdr[11]<<8) | hdr[12];
	h = (hdr[13]<<24) | (hdr[14]<<16) | (hdr[15]<<8) | hdr[16];

	surf = SDL_CreateRGBSurface(SDL_SWSURFACE, w, h, 32,
	                            *(Uint32 *)rmask, *(Uint32 *)gmask,
	                            *(Uint32 *)bmask, *(Uint32 *)amask);
	if (!surf)
		return NULL;

	if (SDL_RWread(ctx, surf->pixels, 4, w*h) < w*h) {
		SDL_FreeSurface(surf);
		return NULL;
	}

	return surf;
}

